using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace tr
{
    public partial class Form1 : Form
    {
        private int curValue;


        public Form1()
        {
            InitializeComponent();
        }

        private void modeChanged(object sender, EventArgs e)
        {
            if (rbBin.Checked)
            {
                SetBinBlock(true);
                Set29Block(false);
                SetHexBlock(false);

                // Transfer the saved int value into a Binary String representation
                textBox1.Text = MakeStringFromInt(curValue, 2);

            }
            else if (rbHex.Checked)
            {
                SetBinBlock(true);
                Set29Block(true);
                SetHexBlock(true);

                textBox1.Text = MakeStringFromInt(curValue, 16);

            }
            else     //Dez
            {
                SetBinBlock(true);
                Set29Block(true);
                SetHexBlock(false);

                textBox1.Text = MakeStringFromInt(curValue, 10);

            }



        }

        private void SetHexBlock(bool b)
        {
            bA.Enabled = b;
            bB.Enabled = b;
            bC.Enabled = b;
            bD.Enabled = b;
            bE.Enabled = b;
            bF.Enabled = b;
        }

        private void Set29Block(bool b)
        {
            b2.Enabled = b;
            b3.Enabled = b;
            b4.Enabled = b;
            b5.Enabled = b;
            b6.Enabled = b;
            b7.Enabled = b;
            b8.Enabled = b;
            b9.Enabled = b;
        }

        private void SetBinBlock(bool b)
        {
            b0.Enabled = b;
            b1.Enabled = b;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            rbDez.Checked = true;
        }

        private void buttonPressed(char c)
        {
            // A button has been pressed ...

            if (rbDez.Checked)
            {
                // Take the current value, make it a string
                string s = MakeStringFromInt(curValue, 10);
                // Attach the pressed number/letter
                s += c;
                // Make it an int again
                curValue = MakeIntFromString(s, 10);
                textBox1.Text = MakeStringFromInt(curValue, 10);
            }
            else if (rbBin.Checked)
            {
                string s = MakeStringFromInt(curValue, 2);
                s += c;
                curValue = MakeIntFromString(s, 2);
                textBox1.Text = MakeStringFromInt(curValue, 2);

            }
            else if (rbHex.Checked)
            {
                string s = MakeStringFromInt(curValue, 16);
                s += c;
                curValue = MakeIntFromString(s, 16);
                textBox1.Text = MakeStringFromInt(curValue, 16);

            }



        }


#region Buttons
        private void b0_Click(object sender, EventArgs e)
        {
            buttonPressed('0');
        }

        private void b1_Click(object sender, EventArgs e)
        {
            buttonPressed('1');
        }

        private void b2_Click(object sender, EventArgs e)
        {
            buttonPressed('2');
        }

        private void b3_Click(object sender, EventArgs e)
        {
            buttonPressed('3');
        }

        private void b4_Click(object sender, EventArgs e)
        {
            buttonPressed('4');
        }

        private void b5_Click(object sender, EventArgs e)
        {
            buttonPressed('5');
        }

        private void b6_Click(object sender, EventArgs e)
        {
            buttonPressed('6');
        }

        private void b7_Click(object sender, EventArgs e)
        {
            buttonPressed('7');
        }

        private void b8_Click(object sender, EventArgs e)
        {
            buttonPressed('8');
        }

        private void b9_Click(object sender, EventArgs e)
        {
            buttonPressed('9');
        }

        private void bA_Click(object sender, EventArgs e)
        {
            buttonPressed('a');
        }

        private void bB_Click(object sender, EventArgs e)
        {
            buttonPressed('b');
        }

        private void bC_Click(object sender, EventArgs e)
        {
            buttonPressed('c');
        }

        private void bD_Click(object sender, EventArgs e)
        {
            buttonPressed('d');
        }

        private void bE_Click(object sender, EventArgs e)
        {
            buttonPressed('e');
        }

        private void bF_Click(object sender, EventArgs e)
        {
            buttonPressed('f');
        }
#endregion


        public int MakeIntFromString(string s, int basis) 
        {
            try
            {
                return Convert.ToInt32(s, basis);
            }
            catch
            {
                return 0;
            }
        }

        public string MakeStringFromInt(int i, int basis)
        {
            try
            {
                return Convert.ToString(i, basis);
            }
            catch
            {
                return "";
            }
        }

    }
}